//=============================================================================
//                                                              PowerSwing.mq4
//                                               Copyright  2009, Xavier Chaparro
//
//=============================================================================
#property copyright "Copyright  2009, Xavier Chaparro"


#property indicator_chart_window
#property indicator_buffers 6
#property indicator_color1 Lime
#property indicator_color2 Red
#property indicator_color3 Lime
#property indicator_color4 Red
#property indicator_color5 Lime
#property indicator_color6 Red

// buffers
double BuyEntryBuf[];
double SellEntryBuf[];
double BuyExitBuf[];
double SellExitBuf[];
double AddBuyBuf[];
double AddSellBuf[];


extern bool			IsEA_Calling		= false;
extern bool			UseAlert			= false;
extern color		LegendColor			= Yellow;
extern int			LegendCorner		= 3;
extern string		Comment9			= "Corner: 0=UL , 1=UR , 2=LL , 3=LR";


// Globals --------------------------------------

// Indicator values
double	HA_HiLo_2, HA_LoHi_2, HA_Open_1, HA_Close_1, HA_Close_0, HA_Open_0, HA_HiLo_0, HA_LoHi_0;
double	HA_DM0_2, HA_DM1_2, HA_Open_2, HA_Close_2;
double	TDI0_1, BlueH_1, Yellow_1,  Yellow_0, BlueL_1, Green_1, Green_0;
double	Red_0, Red_1, Red_2, BlueH_0, BlueL_0, rf;
double	MA_Hi_0, MA_Lo_0;
double	MA_Hi_1, MA_Lo_1;
double	MA_Hi_2, MA_Lo_2;
double	Chaikin;
int   SonicGreen0,SonicGreen1,SonicRed0,SonicRed1,SonicYellow0,SonicYellow1;
double OffBlue0,OffBlue1,OffRed0,OffRed1;
double Trendline0,Trendline1,Trendline2,Trendline3;

// Other
int			TDI_Dir;
int			MA_Trend_Dir;
int			H4_Trend;
int			HA_Outside_MA_Dir;
bool		HA_Closed_Inside_MA;
int			CandleSmallerOrOpp;
string		ExitReason;
datetime 	PrevTime, PAChannel;



//=============================================================================
// Custom indicator initialization & deinitialization functions
//=============================================================================
int init()
{
	// Entry arrow
	SetIndexStyle(0,DRAW_ARROW);
	SetIndexArrow(0,233);
	SetIndexBuffer(0,BuyEntryBuf);
	SetIndexEmptyValue(0,0.0);
	SetIndexStyle(1,DRAW_ARROW);
	SetIndexArrow(1,234);
	SetIndexBuffer(1,SellEntryBuf);
	SetIndexEmptyValue(1,0.0);
	
	// Exit arrow
	SetIndexStyle(2,DRAW_ARROW);
	SetIndexArrow(2,251);
	SetIndexBuffer(2,BuyExitBuf);
	SetIndexEmptyValue(2,0.0);
	SetIndexStyle(3,DRAW_ARROW);
	SetIndexArrow(3,251);
	SetIndexBuffer(3,SellExitBuf);
	SetIndexEmptyValue(3,0.0);
	
	// Possible add-to-trade arrow
	SetIndexStyle(4,DRAW_ARROW);
	SetIndexArrow(4,241);
	SetIndexBuffer(4,AddBuyBuf);
	SetIndexEmptyValue(4,0.0);
	SetIndexStyle(5,DRAW_ARROW);
	SetIndexArrow(5,242);
	SetIndexBuffer(5,AddSellBuf);
	SetIndexEmptyValue(5,0.0);

	int y1 = 50, y2 = 40, y3 = 30, y4 = 20, y5 = 10;
	if (!IsEA_Calling)
	{
		if (LegendCorner == 0 || LegendCorner == 1)
		{
			y1 = 10; y2 = 20; y3 = 30; y4 = 40; y5 = 50;
		}
	

	}	
	return(0);
}


int deinit()
{
	if (!IsEA_Calling)
	{
		string name;
		for (int i = Bars; i >= 0; i--)
		{
			name = "PowerSwingBuy" + DoubleToStr(i ,0);
			ObjectDelete(name);
			name = "PowerSwingSell" + DoubleToStr(i ,0);
			ObjectDelete(name);
		}
		ObjectDelete("TotalPips");
		ObjectDelete("Legend1");
		ObjectDelete("Legend2");
		ObjectDelete("Legend3");
		ObjectDelete("Legend4");
		ObjectDelete("Legend5");
	}
	return(0);
}


//=============================================================================
//| Custom indicator iteration function                              |
//=============================================================================
int start()
{
	static int		RunningTotal = 0;
	static bool 	InBuy = false;
	static bool 	InSell = false;
	static double	OpenPriceB = 0;
	static double	OpenPriceS = 0;

	int 	i, limit;
	double	a, b, c, d, e, f, g;
	int		pipsMade;
	color	clr;
	string	name, text;
	double	upperPos, lowerPos, upperTextPos, lowerTextPos;
	double	spread;
	
	// Run only once per candle
	if (PrevTime == Time[0])
		return;
	PrevTime = Time[0];

	// Get already counted bars    
	int counted_bars = IndicatorCounted();

	// Check for possible errors
	if (counted_bars < 0) 
		return (-1);
		
	limit = Bars - counted_bars - 1;
	
	// Don't do ALL the way back to start, 
	// because we reference earlier candles
	if (limit > 100)
		limit -= 5;
	
	int sp = 3;
	switch (Period())
	{
		case PERIOD_M5:		sp = 5; 	break;
		case PERIOD_M15:	sp = 8; 	break;
		case PERIOD_M30:	sp = 10; 	break;
		case PERIOD_H1:		sp = 15; 	break;
		case PERIOD_H4:		sp = 35; 	break;
		case PERIOD_D1:		sp = 90; 	break;
		case PERIOD_W1:		sp = 120; 	break;
		case PERIOD_MN1:	sp = 170; 	break;
	}
	
	// Main loop
	for (i = limit; i >= 0; i--) 
	{
		AcquireIndicatorValues(i);
//		Print("Trendline0 ",Trendline0," Trendline1 ",Trendline1," Trendline2 ", Trendline2," Trendline3 ", Trendline3);
		// Check for open signals ---------------------------------------------
		
		
		// Calculate where to put arrows (and labels)
		upperPos = MathMax(High[i], MathMax(HA_HiLo_2, HA_LoHi_2)) + ((4+sp)*Point);
		upperTextPos = upperPos + ((sp+2)*Point);
		lowerPos = MathMin(Low[i], MathMin(HA_HiLo_2, HA_LoHi_2)) - ((4+sp)*Point);
		lowerTextPos = lowerPos - ((sp+2)*Point);
		spread = Ask - Bid;
//      spread = 0.0002;
		
		// If all in Long position, signal to BUY at this candle's open
		if (!InBuy && 
			GetSonic_EntryDir() == OP_BUY &&  GetOfftrend_EntryDir()== OP_BUY  )
		{
			BuyEntryBuf[i] = lowerPos;
			InBuy = true;
			OpenPriceB = Open[i] + spread;
			DoAlert(i, "PowerSwing: "+Symbol()+"  New Buy Signal " + Bid);
		}
		
		
		
		// If all in Short position, signal to SELL at this candle's open
		if (!InSell  && 
			GetSonic_EntryDir() == OP_SELL &&  GetOfftrend_EntryDir()== OP_SELL  )
		{
			SellEntryBuf[i] = upperPos;
			InSell = true;
			OpenPriceS = Open[i] - spread;
			DoAlert(i, "PowerSwing: "+Symbol()+" New Sell Signal " + Bid);
		}

		
		

		// Check for close signals --------------------------------------------
			
		// If all in Short position, signal to EXIT LONG at this candle's open
		if (InBuy &&  (GetTrendline_ExitDir() == OP_SELL ))
		{
			BuyExitBuf[i] = upperPos;
			InBuy = false;
			pipsMade = (Open[i] - OpenPriceB) / Point;
			RunningTotal += pipsMade;

			// Create label for pips made for this trade
			clr = Red;
			if (pipsMade >= 0)
				clr = Lime;

			if (!IsEA_Calling)
			{
				name = "PowerSwingBuy" + DoubleToStr(i ,0);
				text = DoubleToStr(pipsMade ,0) + " Pips ";
				ObjectCreate(name, OBJ_TEXT, 0, Time[i], upperTextPos);
				ObjectSetText(name, text, 8, "Times New Roman", clr);
				DoAlert(i, "PowerSwing: "+Symbol()+" Exit Buy Signal " + Bid);
			}
		}
				
		// If all in Long position, signal to EXIT SHORT position at this candle's open
		if (InSell &&  (GetTrendline_ExitDir() == OP_BUY ))
		{
			SellExitBuf[i] = lowerPos;
			InSell = false;
			pipsMade = (OpenPriceS - Open[i]) / Point;
			RunningTotal += pipsMade;

			// Create label for pips made for this trade
			clr = Red;
			if (pipsMade >= 0)
				clr = Lime;

			if (!IsEA_Calling)
			{
				name = "PowerSwingSell" + DoubleToStr(i ,0);
				text = DoubleToStr(pipsMade ,0) + " Pips ";
				ObjectCreate(name, OBJ_TEXT, 0, Time[i], lowerTextPos);
				ObjectSetText(name, text, 8, "Times New Roman", clr);
				DoAlert(i, "PowerSwing: "+Symbol()+" Exit Sell Signal" + Bid);
			}
		}
//		Print("i == " + i + "        InBuy == " + InBuy + "        InSell == " + InSell);
	}

	// On zero (most recent) candle, put up the total (only once)
	if (!IsEA_Calling)
	{
		ObjectDelete("TotalPips");
		text = DoubleToStr(RunningTotal ,0) + " pips: " + Bars + " Bars" ;
		ObjectCreate("TotalPips", OBJ_TEXT, 0, Time[0], upperTextPos + sp*Point);
		ObjectSetText("TotalPips", text, 10, "Times New Roman", Yellow);
	}

	return(0);
}


void DoAlert(int i, string str)
{
	if (UseAlert && i == 0 && !IsEA_Calling)
		Alert(str);
}


void AcquireIndicatorValues(int i) 
{
	// Get Haiken Ashi values (now closed candle)
	HA_Open_0  = iCustom(NULL, 0, "HeikenAshi_DM",   2, i); // Open
	HA_Close_0 = iCustom(NULL, 0, "HeikenAshi_DM",   3, i); // Close
	HA_HiLo_0  = iCustom(NULL, 0, "HeikenAshi_DM",   0, i); // Low  (if long, else High)
	HA_LoHi_0  = iCustom(NULL, 0, "HeikenAshi_DM",   1, i); // High (if long, else Low)
	
	// Get Haiken Ashi values (last closed candle)
	HA_HiLo_2  = iCustom(NULL, 0, "HeikenAshi_DM",   0, i+1); // Low  (if long, else High)
	HA_LoHi_2  = iCustom(NULL, 0, "HeikenAshi_DM",   1, i+1); // High (if long, else Low)
	HA_Open_1  = iCustom(NULL, 0, "HeikenAshi_DM",   2, i+1); // Open
	HA_Close_1 = iCustom(NULL, 0, "HeikenAshi_DM",   3, i+1); // Close
	
	// Get Haiken Ashi values (one prior to last closed candle)
	HA_Open_2 = iCustom(NULL, 0, "HeikenAshi_DM",   2, i+2); // Open
	HA_Close_2 = iCustom(NULL, 0, "HeikenAshi_DM",   3, i+2); // Close
	
	
	// Get Smoothed Moving Average values
	MA_Hi_0 = iMA(NULL, 0, 5, 0, MODE_SMMA, PRICE_HIGH, i);
	MA_Lo_0 = iMA(NULL, 0, 5, 0, MODE_SMMA, PRICE_LOW, i);
	MA_Hi_1 = iMA(NULL, 0, 5, 0, MODE_SMMA, PRICE_HIGH, i+1);
	MA_Lo_1 = iMA(NULL, 0, 5, 0, MODE_SMMA, PRICE_LOW, i+1);
	MA_Hi_2 = iMA(NULL, 0, 5, 0, MODE_SMMA, PRICE_HIGH, i+2);
	MA_Lo_2 = iMA(NULL, 0, 5, 0, MODE_SMMA, PRICE_LOW, i+2);

   
     // Get Sonic Slope
   SonicGreen0 = iCustom(NULL, 0, "THV Sonic_Slope", 0, i);
   SonicGreen1 = iCustom(NULL, 0, "THV Sonic_Slope", 0, i+1);
   SonicRed0 = iCustom(NULL, 0, "THV Sonic_Slope", 1, i);
   SonicRed1 = iCustom(NULL, 0, "THV Sonic_Slope", 1, i+1);
   SonicYellow0 = iCustom(NULL, 0, "THV Sonic_Slope", 2, i);
   SonicYellow1 = iCustom(NULL, 0, "THV Sonic_Slope", 2, i+1);
   
       // Get Trendline
   Trendline1 = iCustom(NULL, 0, "trendline", 0, i);
   Trendline2 = iCustom(NULL, 0, "trendline", 1, i);
 

	 // Get offtrend
   OffBlue0 = iCustom(NULL, 0, "ForexOffTrend_Alert", 400,6,1.6,50.6,0, i);
   OffBlue1 = iCustom(NULL, 0, "ForexOffTrend_Alert", 400,6,1.6,50.6,0, i+1);
   OffRed0 = iCustom(NULL, 0, "ForexOffTrend_Alert", 400,6,1.6,50.6,1, i);
   OffRed1 = iCustom(NULL, 0, "ForexOffTrend_Alert", 400,6,1.6,50.6,1, i+1);
	

}









int GetSonic_EntryDir()
{
	if ((SonicYellow0 == 2 && SonicRed1 == 2 ) ||
	( SonicYellow1 == 2 && SonicGreen0 == 2)) 
		
		return(OP_BUY);
	else 
	if ((SonicYellow0 == 2 && SonicGreen1 == 2 ) ||
	( SonicYellow1 == 2 && SonicRed0 == 2 ))
		return(OP_SELL);
	return(-1);
}

int GetOfftrend_EntryDir()
{
	if ((OffBlue0 >  OffRed0) && ( OffBlue0 > OffBlue1))  
		
		return(OP_BUY);
	else 
	if ((OffBlue0 <  OffRed0 ) && ( OffBlue0 < OffBlue1))
		return(OP_SELL);
	return(-1);
}



int GetTrendline_ExitDir()
{
	// Check for exiting Buy position
	if (OffBlue0 < Trendline2)
	{
		ExitReason = "Trend";
		return(OP_SELL);
	}
	else 
	// Check for exiting sell position
	if (OffBlue0 > Trendline2) 
	{
		ExitReason = "Trend";
		return(OP_BUY);
	}
	return(-1);
}












